# Klassifieds: A Klassifieds Advertising SystemK
# by Andrew Veitch
# Released under the GNU Public License

__version__='0.21'

from Products.ZCatalog.CatalogPathAwareness import CatalogAware
from Globals import Persistent, DTMLFile
from Acquisition import Implicit
from OFS.SimpleItem import Item
import random

class Advert(CatalogAware, Item, Persistent, Implicit):
    "A Klassifieds Advert"

    meta_type="Klassifieds Advert"

    def __init__ (self, id, Name, Street, City, State, Zip, Telephone, Country,
            Email, Website, Display, Categories, title, AdvertText, Password, 
            Expires, Maillist, Posted, Approved, Verified):
        self.id = id
        self.Pageviews = 0
        self.Photo = ""
        self.Verified = Verified
        self.Secret = str(random.randrange(1,999999))
        self.editAdvert(Name, Street, City, State, Zip, Telephone, Country,
            Email, Website, Categories, title, AdvertText, Password, Expires,
            Posted, Approved, Display, Maillist)

    def editAdvert (self, Name, Street, City, State, Zip, Telephone, Country,
            Email, Website, Categories, title, AdvertText, Password, Expires,
            Posted, Approved = "", Display = "", Maillist = "",
            REQUEST=None):
        "Method for updating Adverts"
        self.Name = Name
        self.Street = Street
        self.City = City
        self.State = State
        self.Zip = Zip
        self.Telephone = Telephone
        self.Country = Country
        self.Email = Email
        if len(Website) > 7:
            if Website[0:7] != 'http://':
                Website = 'http://' + Website
        self.Website = Website
        self.Display = Display
        self.Categories = Categories
        self.title = title
        self.AdvertText = AdvertText
        self.Password = Password
        self.Expires = Expires
        self.Maillist = Maillist
        self.Posted = Posted
        self.Approved = Approved
        self.reindex_object()
        if REQUEST is not None:
            return self.index_html(self, REQUEST)

    def getPageviews(self):
        "Return number of page views & increment counter"
        self.Pageviews = self.Pageviews + 1
        return self.Pageviews

    def setPhoto(self):
        "Set the Photo boolean to true, called if a photo is uploaded"
        self.Photo = "on"
        self.reindex_object()

    def setApproved(self):
        "Set the Approved boolean to true, called when moderator approves"
        self.Approved = "on"
        self.reindex_object()

    def setVerified(self):
        "Set Verfied to true, called from verifyEmail.dtml"
        self.Verified = "on"
        self.reindex_object()

    editAdvertForm = DTMLFile("dtml/editAdvertForm", globals())
    emailForm = DTMLFile("dtml/emailForm", globals())
    emailSend = DTMLFile("dtml/emailSend", globals())
    index_html = DTMLFile("dtml/advertDetails", globals())
    addPhoto = DTMLFile("dtml/addPhoto", globals())
    addPhotoForm = DTMLFile("dtml/addPhotoForm", globals())
    editPassword = DTMLFile("dtml/editPassword", globals())
    verifyEmail = DTMLFile("dtml/verifyEmail", globals())
    replyForm = DTMLFile("dtml/replyForm", globals())
    replySend = DTMLFile("dtml/replySend", globals())
